<?php
/**
* @title        Minitek Slider
* @copyright    Copyright (C) 2011-2020 Minitek, All rights reserved.
* @license      GNU General Public License version 3 or later.
* @author url   https://www.minitek.gr/
* @developers   Minitek.gr
*/

defined('_JEXEC') or die;

if(!defined('DS')){
	define('DS',DIRECTORY_SEPARATOR);
}

class MinitekSliderControllerWidgets extends JControllerAdmin
{
	protected $text_prefix = 'COM_MINITEKSLIDER';

	public function getModel($name = 'Widget', $prefix = 'MinitekSliderModel', $config = array('ignore_request' => true))
	{
		$model = parent::getModel($name, $prefix, $config);

		return $model;
	}

	public function deleteCroppedImages()
	{
		// Delete images folder
		jimport('joomla.filesystem.folder');
		JSession::checkToken('request') or jexit('Invalid token');
		$app = JFactory::getApplication();

		$tmppath = JPATH_SITE.DS.'images'.DS.'msliderimages'.DS;
		if (file_exists($tmppath))
		{
			JFolder::delete($tmppath);
			$message = JText::_('COM_MINITEKSLIDER_CROPPED_IMAGES_DELETED');
			$link = JRoute::_('index.php?option=com_minitekslider&view=widgets');
			$app->redirect(str_replace('&amp;', '&', $link), $message, 'message');
		}
		else
		{
			$message = JText::_('COM_MINITEKSLIDER_CROPPED_IMAGES_NOT_FOUND');
			$link = JRoute::_('index.php?option=com_minitekslider&view=widgets');
			$app->redirect(str_replace('&amp;', '&', $link), $message, 'notice');
		}
	}
}
