<?php
/**
* @title				Minitek Slider
* @copyright   	Copyright (C) 2011-2020 Minitek, All rights reserved.
* @license   		GNU General Public License version 3 or later.
* @author url   https://www.minitek.gr/
* @developers   Minitek.gr
*/

defined('_JEXEC') or die;

class JFormFieldProFeature extends JFormField
{
	public $type = 'profeature';
	private $params = null;

	protected function getInput()
	{
		$this->params = $this->element->attributes();

		$title = $this->get('title');
		$description = $this->get('description');
		$class = $this->get('class');
		$html = '';

		if ($description)
		{
			$html = '<div class="alert alert-'.$class.'">
			<i class="fa fa-lock"></i>&nbsp;&nbsp;';
			if ($title)
			{
				$html .= JText::_($title).'&nbsp;&nbsp;';
			}
			$html .= '<a href="https://www.minitek.gr/joomla/extensions/minitek-slider#subscriptionPlans">'.JText::_('COM_MINITEKSLIDER_UPGRADE_TO_PRO').'</a>
			</div>';
		}

		return $html;
	}

	private function get($val, $default = '')
	{
		return (isset($this->params[$val]) && (string) $this->params[$val] != '') ? (string) $this->params[$val] : $default;
	}
}
