<?php
/**
* @title				Minitek Slider
* @copyright   	Copyright (C) 2011-2020 Minitek, All rights reserved.
* @license   		GNU General Public License version 3 or later.
* @author url   https://www.minitek.gr/
* @developers   Minitek.gr
*/

defined('_JEXEC') or die;

class MinitekSliderViewDashboard extends JViewLegacy
{
	public function display($tpl = null)
	{
		$this->utilities = new MinitekSliderHelperUtilities();

		// Skip if view == update
		if (JFactory::getApplication()->input->get('view') != 'update')
		{
			// Load dashboard.js
			JHtml::_('bootstrap.framework');
			JFactory::getDocument()->addScript(JURI::root(true).'/administrator/components/com_minitekslider/assets/js/dashboard.js');

			// Check for Minitek authentication plugin
			$this->authEnabled = $this->utilities->getMinitekAuthPlugin();

			$this->addToolbar();

			parent::display($tpl);
		}
	}

	protected function addToolbar()
	{
		JToolbarHelper::title(JText::_('COM_MINITEKSLIDER_DASHBOARD_TITLE'), '');
	}
}
