<?php
/**
* @title				Minitek Slider
* @copyright   	Copyright (C) 2011-2019 Minitek, All rights reserved.
* @license   		GNU General Public License version 3 or later.
* @author url   https://www.minitek.gr/
* @developers   Minitek.gr
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class MinitekSliderViewSlider extends JViewLegacy
{
	function display($tpl = null)
	{
 		$document = JFactory::getDocument();
		$this->model = $this->getModel();
		$utilities = $this->model->utilities;
		$this->assignRef('utilities', $utilities);
		$params = $utilities->getParams('com_minitekslider');
		$this->assignRef('params', $params);
		$jinput = JFactory::getApplication()->input;
		$widgetID = $jinput->get('widget_id');
		$page = $jinput->get('page', '1', 'INT');
		$this->page = $page;

		// Get slider parameters
		$slider_params = $utilities->getSliderParams($widgetID);

		if (!isset($slider_params['slider_theme']))
		{
			JError::raiseError(404, JText::_('COM_MINITEKSLIDER_WIDGET_NOT_FOUND'));
			return false;
		}
		// If component was upgraded from free version, make sure the widget is saved again.
		else if (!isset($slider_params['slider_crop_images']))
		{
			JError::raiseError(404, JText::_('COM_MINITEKSLIDER_WIDGET_MUST_BE_SAVED'));
			return false;
		}

		// Get slider type
		$theme = $slider_params['slider_theme'];
		$slider_layout = $theme;
		$suffix = $slider_params['slider_suffix'];
		$cont_padding = (int)$slider_params['slider_cont_padding'];
		$gutter = (int)$slider_params['slider_gutter'];
		$border_radius = (int)$slider_params['slider_border_radius'];
		$border = (int)$slider_params['slider_border'];
		$border_color = $slider_params['slider_border_color'];

		// Images
		$slider_images = $slider_params['slider_images'];
		$this->slider_image_link = true;
		if (array_key_exists('slider_image_link', $slider_params))
		{
			$this->slider_image_link = $slider_params['slider_image_link'];
		}
		$slider_crop_images = $slider_params['slider_crop_images'];
		$slider_image_width = (int)$slider_params['slider_image_width'];
		$slider_image_height = (int)$slider_params['slider_image_height'];
		$slider_lazyload = $slider_params['slider_lazyload'];
		$slider_fallback_image = $slider_params['slider_fallback_image'];

		// Get navigation
		$navigator = $slider_params['slider_navigator'];
		$navigator_width = (int)$slider_params['slider_navigator_width'];
		$navigator_height = (int)$slider_params['slider_navigator_height'];
		$navigator_images = $slider_params['slider_navigator_images'];
		$navigator_spacing = (int)$slider_params['slider_navigator_spacing'];
		$navigator_db = $slider_params['slider_navigator_db'];
		$navigator_db_text_color = $slider_params['slider_navigator_db_text_color'];
		$navigator_db_color = $slider_params['slider_navigator_db_color'];
		$navigator_db_color = $utilities->hex2RGB($navigator_db_color, true);
		$navigator_db_opacity = $slider_params['slider_navigator_db_opacity'];
		$navigator_db_opacity = number_format((float)$navigator_db_opacity, 2, '.', '');
		$navigator_db_date = $slider_params['slider_navigator_db_date'];
		$navigator_db_title = $slider_params['slider_navigator_db_title'];
		$navigator_db_category = $slider_params['slider_navigator_db_category'];
		$navigator_db_location = $slider_params['slider_navigator_db_location'];
		$navigator_db_author = $slider_params['slider_navigator_db_author'];
		$navigator_db_price = $slider_params['slider_navigator_db_price'];
		$arrows = $slider_params['slider_arrows'];
		$this->horizontal_padding = 
			isset($slider_params['slider_overlay_arrows']) && $slider_params['slider_overlay_arrows'] 
			? false 
			: true;
		$bullets = $slider_params['slider_bullets'];
		$bullets_style = $slider_params['slider_bullets_style'];
		$progressbar = $slider_params['slider_progressbar'];

		if ($page === '1')
		{
			// Get Total count
			$totalCount = $this->model->getAllResultsCount($widgetID);

			// Load css
			$document->addStyleSheet(JURI::base().'components/com_minitekslider/assets/css/flickity.css');
			$document->addStyleSheet(JURI::base().'components/com_minitekslider/assets/css/slider.css');
			if ($slider_params['slider_fullscreen'])
			{
				$document->addStyleSheet(JURI::base().'components/com_minitekslider/assets/css/flickity.fullscreen.css');
			}
			if ($slider_params['slider_fade'])
			{
				$document->addStyleSheet(JURI::base().'components/com_minitekslider/assets/css/flickity.fade.css');
			}

			$slider_css = $this->model->slider_css;
			$slider_css->loadResponsiveSlider($slider_params, $widgetID);
			$slider_css->loadDynamicCss($slider_params, $widgetID);

			// Load scripts
			$document->addCustomTag('<script src="'.JURI::base().'components/com_minitekslider/assets/js/flickity.pkgd.min.js" type="text/javascript"></script>');
			if ($slider_params['slider_fullscreen'])
			{
				$document->addCustomTag('<script src="'.JURI::base().'components/com_minitekslider/assets/js/flickity.fullscreen.js" type="text/javascript"></script>');
			}
			if ($slider_params['slider_fade'])
			{
				$document->addCustomTag('<script src="'.JURI::base().'components/com_minitekslider/assets/js/flickity.fade.js" type="text/javascript"></script>');
			}
			if ($slider_params['slider_load_more'])
			{
				$document->addCustomTag('<script src="'.JURI::base().'/components/com_minitekslider/assets/js/spin.min.js" type="text/javascript"></script>');
			}

			// Load lightbox
			$lightbox = false;
			if ($slider_params['slider_hb'] && isset($slider_params['slider_hb_lightbox']) && $slider_params['slider_hb_lightbox'] && $params->get('load_lightbox', true))
			{
				$lightbox = true;
				$document->addStyleSheet(JURI::base(true).'/components/com_minitekslider/assets/lightbox/lightbox.min.css');
				$document->addCustomTag('<script src="'.JURI::base(true).'/components/com_minitekslider/assets/lightbox/lightbox.min.js" type="text/javascript"></script>');
			}

			// Load javascript.php
			$slider_javascript = $this->model->slider_javascript;
			$slider_javascript->loadSliderJavascript($slider_params, $widgetID, $totalCount);
		}

		// Detail box
		$detailBox = $slider_params['slider_db'];
		$detailBoxBackground = $slider_params['slider_db_bg'];
		$detailBoxBackground = $utilities->hex2RGB($detailBoxBackground, true);
		$detailBoxBackgroundOpacity = $slider_params['slider_db_bg_opacity'];
		$detailBoxBackgroundOpacity = number_format((float)$detailBoxBackgroundOpacity, 2, '.', '');
		$detailBoxTextColor = $slider_params['slider_db_color'];
		$detailBoxTitle = $slider_params['slider_db_title'];
		$this->detailBoxTitleLink = true;
		if (array_key_exists('slider_db_title_link', $slider_params))
		{
			$this->detailBoxTitleLink = $slider_params['slider_db_title_link'];
		}
		$detailBoxTitleLimit = $slider_params['slider_db_title_limit'];
		$detailBoxIntrotext = $slider_params['slider_db_introtext'];
		$detailBoxIntrotextLimit = $slider_params['slider_db_introtext_limit'];
		$detailBoxStripTags = $slider_params['slider_db_strip_tags'];
		$detailBoxDate = $slider_params['slider_db_date'];
		$detailBoxDateFormat = $slider_params['slider_db_date_format'];
		$detailBoxCategory = $slider_params['slider_db_category'];
		$detailBoxLocation = $slider_params['slider_db_location'];
		$detailBoxType = $slider_params['slider_db_content_type'];
		$detailBoxAuthor = $slider_params['slider_db_author'];
		$detailBoxPrice = $slider_params['slider_db_price'];
		$detailBoxHits = $slider_params['slider_db_hits'];
		$detailBoxCount = $slider_params['slider_db_count'];
		$detailBoxReadmore = $slider_params['slider_db_readmore'];

		// Hover box
		$hoverBox = $slider_params['slider_hb'];
		$hoverBoxBg = $slider_params['slider_hb_bg'];
		$hoverBoxBgOpacity = $slider_params['slider_hb_bg_opacity'];
		$hoverBoxTextColor = $slider_params['slider_hb_text_color'];
		$hoverBoxEffect = $slider_params['slider_hb_effect'];
		$hoverBoxEffectSpeed = $slider_params['slider_hb_effect_speed'];
		$hoverBoxEffectEasing = $slider_params['slider_hb_effect_easing'];
		$hoverBoxTitle = $slider_params['slider_hb_title'];
		$hoverBoxTitleLimit = $slider_params['slider_hb_title_limit'];
		$hoverBoxIntrotext = $slider_params['slider_hb_introtext'];
		$hoverBoxIntrotextLimit = $slider_params['slider_hb_introtext_limit'];
		$hoverBoxStripTags = $slider_params['slider_hb_strip_tags'];
		$hoverBoxDate = $slider_params['slider_hb_date'];
		$hoverBoxDateFormat = $slider_params['slider_hb_date_format'];
		$hoverBoxCategory = $slider_params['slider_hb_category'];
		$hoverBoxLocation = $slider_params['slider_hb_location'];
		$hoverBoxType = $slider_params['slider_hb_type'];
		$hoverBoxAuthor = $slider_params['slider_hb_author'];
		$hoverBoxPrice = $slider_params['slider_hb_price'];
		$hoverBoxHits = $slider_params['slider_hb_hits'];
		$hoverBoxLinkButton = $slider_params['slider_hb_link'];
		$hoverBoxLightboxButton = false;
		if (isset($slider_params['slider_hb_lightbox']))
		{
			$hoverBoxLightboxButton = $slider_params['slider_hb_lightbox'];
		}

		// Hover effects
		$hoverEffectClass = '';
		if ($hoverBoxEffect == '4')
		{
			$hoverEffectClass = 'slideInRight';
		}
		if ($hoverBoxEffect == '5')
		{
			$hoverEffectClass = 'slideInLeft';
		}
		if ($hoverBoxEffect == '6')
		{
			$hoverEffectClass = 'slideInTop';
		}
		if ($hoverBoxEffect == '7')
		{
			$hoverEffectClass = 'slideInBottom';
		}
		if ($hoverBoxEffect == '8')
		{
			$hoverEffectClass = 'msliderzoomIn';
		}

		// Transition styles
		$animated = '';
		if ($hoverBoxEffect != 'no' && $hoverBoxEffect != '2' && $hoverBoxEffect != '3')
		{
			$animated = '
			transition: all '.$hoverBoxEffectSpeed.'s '.$hoverBoxEffectEasing.' 0s;
			-webkit-transition: all '.$hoverBoxEffectSpeed.'s '.$hoverBoxEffectEasing.' 0s;
			-o-transition: all '.$hoverBoxEffectSpeed.'s '.$hoverBoxEffectEasing.' 0s;
			-ms-transition: all '.$hoverBoxEffectSpeed.'s '.$hoverBoxEffectEasing.' 0s;
			';
		}
		$animated_flip = '';
		if ($hoverBoxEffect == '2' || $hoverBoxEffect == '3')
		{
			$animated_flip = '
			transition: all '.$hoverBoxEffectSpeed.'s '.$hoverBoxEffectEasing.' 0s;
			-webkit-transition: all '.$hoverBoxEffectSpeed.'s '.$hoverBoxEffectEasing.' 0s;
			-o-transition: all '.$hoverBoxEffectSpeed.'s '.$hoverBoxEffectEasing.' 0s;
			-ms-transition: all '.$hoverBoxEffectSpeed.'s '.$hoverBoxEffectEasing.' 0s;
			';
		}

		// Hover box background
		$hb_bg_class = $this->utilities->hex2RGB($hoverBoxBg, true);
		$hb_bg_opacity_class = number_format((float)$hoverBoxBgOpacity, 2, '.', '');

		// Hover box text color
		if ($hoverBoxTextColor == '1') {
			$hoverTextColor = 'dark-text';
		} else {
			$hoverTextColor = 'light-text';
		}

		// Get Slider
		if ($page === '1')
		{
			$slider = $this->model->getAllResults($widgetID);
		}
		else
		{
			$slider = $this->model->getAllResultsAjax($widgetID);
		}

		if (!$slider)
		{
			return;
		}

		// Create display params
		$detailBoxParams = array();
		$detailBoxParams['images'] = $slider_images;
		$detailBoxParams['crop_images'] = $slider_crop_images;
		$detailBoxParams['image_width'] = $slider_image_width;
		$detailBoxParams['image_height'] = $slider_image_height;
		$detailBoxParams['fallback_image'] = $slider_fallback_image;
		$detailBoxParams['detailBoxTitleLimit'] = $detailBoxTitleLimit;
		$detailBoxParams['detailBoxIntrotextLimit'] = $detailBoxIntrotextLimit;
		$detailBoxParams['detailBoxStripTags'] = $detailBoxStripTags;
		$detailBoxParams['detailBoxDateFormat'] = $detailBoxDateFormat;

		$hoverBoxParams = array();
		$hoverBoxParams['hoverBox'] = $hoverBox;
		$hoverBoxParams['hoverBoxTitle'] = $hoverBoxTitle;
		$hoverBoxParams['hoverBoxTitleLimit'] = $hoverBoxTitleLimit;
		$hoverBoxParams['hoverBoxIntrotext'] = $hoverBoxIntrotext;
		$hoverBoxParams['hoverBoxIntrotextLimit'] = $hoverBoxIntrotextLimit;
		$hoverBoxParams['hoverBoxStripTags'] = $hoverBoxStripTags;
		$hoverBoxParams['hoverBoxDate'] = $hoverBoxDate;
		$hoverBoxParams['hoverBoxDateFormat'] = $hoverBoxDateFormat;

		$navParams = array();
		$navParams['navigator'] = $navigator;
		$navParams['navigator_width'] = $navigator_width;
		$navParams['navigator_height'] = $navigator_height;
		$navParams['navigator_images'] = $navigator_images;
		$navParams['navigator_border'] = $slider_params['slider_navigator_border'];

		// Get widget with display options
		$options = $this->model->options;
		$slider = $options->getWidgetDisplayOptions($widgetID, $slider, $detailBoxParams, $hoverBoxParams, $navParams);

		// Display Slider
		if (!$slider || $slider == '' || $slider == 0)
		{
			$output = '<div class="mslider-results-empty-results">';
			$output .= '<span>'.JText::_('COM_MINITEKSLIDER_NO_ITEMS').'</span>';
			$output .= '</div>';
			echo $output;
		}
		else
		{
			// Assign variables
			$this->assignRef('widgetID', $widgetID);
			$this->assignRef('slider', $slider);

			// Slider
			$this->assignRef('theme', $theme);
			$this->assignRef('slider_layout', $slider_layout);
			$this->assignRef('suffix', $suffix);
			$this->assignRef('cont_padding', $cont_padding);
			$this->assignRef('gutter', $gutter);
			$this->assignRef('border_radius', $border_radius);
			$this->assignRef('border', $border);
			$this->assignRef('border_color', $border_color);
			$this->assignRef('slider_images', $slider_images);
			$this->assignRef('slider_image_width', $slider_image_width);
			$this->assignRef('slider_image_height', $slider_image_height);
			$this->assignRef('slider_lazyload', $slider_lazyload);
			$this->assignRef('animated', $animated);
			$this->assignRef('animated_flip', $animated_flip);
			$this->assignRef('hb_bg_class', $hb_bg_class);
			$this->assignRef('hb_bg_opacity_class', $hb_bg_opacity_class);
			$this->assignRef('hoverTextColor', $hoverTextColor);

			// Navigation
			$this->assignRef('navigator', $navigator);
			$this->assignRef('navigator_spacing', $navigator_spacing);
			$this->assignRef('navigator_images', $navigator_images);
			$this->assignRef('navigator_db', $navigator_db);
			$this->assignRef('navigator_db_text_color', $navigator_db_text_color);
			$this->assignRef('navigator_db_color', $navigator_db_color);
			$this->assignRef('navigator_db_opacity', $navigator_db_opacity);
			$this->assignRef('navigator_db_date', $navigator_db_date);
			$this->assignRef('navigator_db_title', $navigator_db_title);
			$this->assignRef('navigator_db_category', $navigator_db_category);
			$this->assignRef('navigator_db_location', $navigator_db_location);
			$this->assignRef('navigator_db_author', $navigator_db_author);
			$this->assignRef('navigator_db_price', $navigator_db_price);
			$this->assignRef('arrows', $arrows);
			$this->assignRef('bullets', $bullets);
			$this->assignRef('bullets_style', $bullets_style);
			$this->assignRef('progressbar', $progressbar);
			$this->assignRef('totalCount', $totalCount);

			// Detail box
			$this->assignRef('detailBox', $detailBox);
			$this->assignRef('detailBoxBackground', $detailBoxBackground);
			$this->assignRef('detailBoxBackgroundOpacity', $detailBoxBackgroundOpacity);
			$this->assignRef('detailBoxTextColor', $detailBoxTextColor);
			$this->assignRef('detailBoxTitle', $detailBoxTitle);
			$this->assignRef('detailBoxIntrotext', $detailBoxIntrotext);
			$this->assignRef('detailBoxDate', $detailBoxDate);
			$this->assignRef('detailBoxCategory', $detailBoxCategory);
			$this->assignRef('detailBoxLocation', $detailBoxLocation);
			$this->assignRef('detailBoxType', $detailBoxType);
			$this->assignRef('detailBoxAuthor', $detailBoxAuthor);
			$this->assignRef('detailBoxPrice', $detailBoxPrice);
			$this->assignRef('detailBoxHits', $detailBoxHits);
			$this->assignRef('detailBoxCount', $detailBoxCount);
			$this->assignRef('detailBoxReadmore', $detailBoxReadmore);

			// Hover box
			$this->assignRef('hoverBox', $hoverBox);
			$this->assignRef('hoverBoxBg', $hoverBoxBg);
			$this->assignRef('hoverBoxBgOpacity', $hoverBoxBgOpacity);
			$this->assignRef('hoverBoxTextColor', $hoverBoxTextColor);
			$this->assignRef('hoverBoxEffect', $hoverBoxEffect);
			$this->assignRef('hoverEffectClass', $hoverEffectClass);
			$this->assignRef('hoverBoxEffectSpeed', $hoverBoxEffectSpeed);
			$this->assignRef('hoverBoxTitle', $hoverBoxTitle);
			$this->assignRef('hoverBoxIntrotext', $hoverBoxIntrotext);
			$this->assignRef('hoverBoxDate', $hoverBoxDate);
			$this->assignRef('hoverBoxCategory', $hoverBoxCategory);
			$this->assignRef('hoverBoxLocation', $hoverBoxLocation);
			$this->assignRef('hoverBoxType', $hoverBoxType);
			$this->assignRef('hoverBoxAuthor', $hoverBoxAuthor);
			$this->assignRef('hoverBoxPrice', $hoverBoxPrice);
			$this->assignRef('hoverBoxHits', $hoverBoxHits);
			$this->assignRef('hoverBoxLinkButton', $hoverBoxLinkButton);
			$this->assignRef('hoverBoxLightboxButton', $hoverBoxLightboxButton);

			if ($page === '1')
			{
				// Because the application sets a default page title,
				// we need to get it from the menu item itself
				$app = JFactory::getApplication();
				$menus = $app->getMenu();
				$menu = $menus->getActive();

				$this->slider_page_title = false;
				if (array_key_exists('slider_page_title', $slider_params) && $slider_params['slider_page_title'])
				{
					$this->slider_page_title = true;

					if ($menu)
					{
						$params->def('page_heading', $params->get('page_title', $menu->title));
					}

					$title = $params->get('page_title', '');

					// Check for empty title and add site name if param is set
					if (empty($title))
					{
						$title = $app->get('sitename');
					}
					elseif ($app->get('sitename_pagetitles', 0) == 1)
					{
						$title = JText::sprintf('JPAGETITLE', $app->get('sitename'), $title);
					}
					elseif ($app->get('sitename_pagetitles', 0) == 2)
					{
						$title = JText::sprintf('JPAGETITLE', $title, $app->get('sitename'));
					}

					$document->setTitle($title);

					if ($params->get('menu-meta_description'))
					{
						$document->setDescription($params->get('menu-meta_description'));
					}

					if ($params->get('menu-meta_keywords'))
					{
						$document->setMetadata('keywords', $params->get('menu-meta_keywords'));
					}

					if ($params->get('robots'))
					{
						$document->setMetadata('robots', $params->get('robots'));
					}
				}

				if (isset($menu->query['option']) && $menu->query['option'] == 'com_minitekslider')
				{
					$title = $params->get('page_title', '');

					// Check for empty title and add site name if param is set
					if (empty($title))
					{
						$title = $app->get('sitename');
					}
					elseif ($app->get('sitename_pagetitles', 0) == 1)
					{
						$title = JText::sprintf('JPAGETITLE', $app->get('sitename'), $title);
					}
					elseif ($app->get('sitename_pagetitles', 0) == 2)
					{
						$title = JText::sprintf('JPAGETITLE', $title, $app->get('sitename'));
					}

					$document->setTitle($title);
				}
			}

			// Check for errors.
			if (count($errors = $this->get('Errors')))
			{
				JError::raiseError(500, implode('<br />', $errors));
				return false;
			}

			// Get Layout
			if ($page === '1')
			{
				$layout = $slider_params['slider_layout'];

				if ($layout)
				{
					$this->setLayout($layout);
					$viewName = $jinput->get('view', 'slider', 'WORD');
					$layoutTemplate = $this->getLayoutTemplate(); // This is empty if the override has the name 'default'. Does not work for modules.
					$this->addTemplatePath(JPATH_SITE.'/templates/'.$layoutTemplate.'/html/com_minitekslider/'.$viewName);
				}
			}

      		parent::display($tpl);
		}
	}
}
